Name:		qubes-utils
Version:	4.2.12
Release:	1%{?dist}
Summary:	Common Linux files for Qubes Dom0 and VM
Source0:    %{name}-%{version}.tar.gz

Group:		Qubes
License:	GPL
URL:		http://www.qubes-os.org

Requires:	udev
Requires:	%{name}-libs
Requires:	GraphicsMagick
Requires:	python%{python3_pkgversion}-qubesimgconverter
Requires:	(%{name}-selinux if selinux-policy)
%{?systemd_requires}
BuildRequires:  systemd
BuildRequires:  python%{python3_pkgversion}-setuptools
BuildRequires:  python3-rpm-macros
# for meminfo-writer
BuildRequires:  xen-devel
BuildRequires:	gcc
BuildRequires:  selinux-policy-devel

%description
Common Linux files for Qubes Dom0 and VM

%package -n python%{python3_pkgversion}-qubesimgconverter
Summary:    Python package qubesimgconverter
Requires:   python%{python3_pkgversion}
Requires:   python%{python3_pkgversion}-cairo
Requires:   python%{python3_pkgversion}-pillow
Requires:   python%{python3_pkgversion}-numpy

%description -n python%{python3_pkgversion}-qubesimgconverter
Python package qubesimgconverter

%package devel
Summary:	Development headers for qubes-utils
Release:	1%{?dist}
Requires:	%{name}-libs

%description devel
Development header and files for qubes-utils

%package libs
Summary: Qubes utils libraries
Release:	1%{?dist}
BuildRequires:	pkgconfig(icu-uc)
BuildRequires:	python3

%description libs
Libraries for qubes-utils

%package selinux

BuildRequires: selinux-policy
%{?selinux_requires}

Summary: SELinux policy for meminfo-writer
License: GPLv2+

%description selinux
SELinux policy for meminfo-writer.  You need this package to run meminfo-writer
on a system where SELinux is in enforcing mode.

%post selinux
%selinux_modules_install %{_datadir}/selinux/packages/qubes-meminfo-writer.pp || :

%postun selinux
if [ "$1" -eq 0 ]; then
    %selinux_modules_uninstall %{_datadir}/selinux/packages/qubes-meminfo-writer.pp
fi || :

%posttrans selinux
%selinux_relabel_post
exit 0

%files selinux
%{_datadir}/selinux/packages/qubes-meminfo-writer.pp
%{_datadir}/selinux/devel/include/contrib/ipp-qubes-meminfo-writer.if

%prep
%setup -q

%build
make all selinux BACKEND_VMM=xen PYTHON=%{__python3} NO_REBUILD_TABLE=1

%check
make -C qrexec-lib check NO_REBUILD_TABLE=1
%if 0%{?fedora} == 38
make -C qrexec-lib check-table-up-to-date NO_REBUILD_TABLE=1
%endif

%install
make install install-selinux DESTDIR=%{buildroot} PYTHON=%{__python3} NO_REBUILD_TABLE=1

%post
# dom0
%systemd_post qubes-meminfo-writer-dom0.service
# VM
%systemd_post qubes-meminfo-writer.service

%preun
%systemd_preun qubes-meminfo-writer-dom0.service
%systemd_preun qubes-meminfo-writer.service

%postun
%systemd_postun_with_restart qubes-meminfo-writer-dom0.service
%systemd_postun_with_restart qubes-meminfo-writer.service

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%_udevrulesdir/*-qubes-*.rules
%_tmpfilesdir/xen-devices-qubes.conf
%{_prefix}/lib/qubes/udev-*
%{_sbindir}/meminfo-writer
%{_unitdir}/qubes-meminfo-writer.service
%{_unitdir}/qubes-meminfo-writer-dom0.service
/etc/xen/scripts/qubes-block

%files -n python%{python3_pkgversion}-qubesimgconverter
%{python3_sitelib}/qubesimgconverter/__init__.py
%{python3_sitelib}/qubesimgconverter/imggen.py
%{python3_sitelib}/qubesimgconverter/test.py
%{python3_sitelib}/qubesimgconverter/test_integ.py
%{python3_sitelib}/qubesimgconverter-%{version}-py?.[0-9]*.egg-info
%{python3_sitelib}/qubesimgconverter/__pycache__

%files libs
%{_libdir}/libqubes-rpc-filecopy.so.2
%{_libdir}/libqubes-pure.so.0

%files devel
%defattr(-,root,root,-)
%_includedir/libqubes-rpc-filecopy.h
%_includedir/qubes/pure.h
%{_libdir}/libqubes-rpc-filecopy.so
%{_libdir}/libqubes-pure.so

%changelog
* Sun Aug 20 2023 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-linux-utils.git

* Sun Aug 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6fe6fac
- version 4.2.12

* Fri Aug 11 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 26c3e30
- debian: split libqubes-pure into separate package

* Tue Jul 04 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d4c9805
- version 4.2.11

* Sat Jul 01 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 80efd31
- libqubes-pure: Add function for qube name validation

* Fri Jun 30 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - dbc5de5
- Add missing entries to .gitignore

* Fri Jun 30 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 91b2cf3
- version 4.2.10

* Mon Jun 26 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9efc9e3
- debian: reduce initramfs size

* Mon May 29 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 73a6d3a
- Update the character allowlist

* Mon May 29 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6c0246c
- version 4.2.9

* Tue May 23 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - d7b5bf9
- Allow meminfo-writer to create and use AF_UNIX stream sockets

* Mon May 22 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - a188c43
- initramfs: Handle the case where device-mapper is a module

* Fri May 12 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5acd9a2
- version 4.2.8

* Fri Apr 28 2023 Rusty Bird <rustybird@net-c.com> - c76eba0
- qubes-block: force logical block size 512 for loop device

* Wed Apr 26 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 30b68a9
- version 4.2.7

* Tue Apr 25 2023 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 9945a12
- archlinux: support for new packaging in legacy builder

* Tue Apr 25 2023 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 9d5f6e8
- Rework Archlinux packaging

* Mon Apr 17 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 755dc10
- qubes-block: Only destroy loop devices qubes-block created

* Mon Apr 17 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 0f8d664
- Fix multiple bugs in block script

* Fri Apr 14 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 17f4162
- ci: make git happy about source clone owned by a different user

* Fri Apr 14 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ed7a5e5
- Switch to new codecov uploader

* Mon Apr 10 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8af10c2
- version 4.2.6

* Sat Mar 18 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - d360a3d
- Write /dev/loopN to physical-device-path

* Sun Mar 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - e84bb22
- Respond to suggestions from code review

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 94066d9
- Always write "diskseq" entry

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - c25e4ed
- Avoid setting a size limit for the loop device

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - eb91a1d
- Add some static assertions

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 1694d8d
- deduplicate loop opening code

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 2d0088a
- Serialize loop device opening

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 98f06b4
- Work around bug in LOOP_CTL_GET_FREE

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 3131d57
- Clean up some error checks

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - edc7b41
- Retry LOOP_CONFIGURE as well as open

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - cd10495
- Always use permissive mode

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - e34df81
- Use different physical-device format for autoclear-enabled kernels

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6fe621a
- Use "opened" Xenstore key instead of magic file in /etc

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 1808a5f
- Use new "opened" Xenstore key to indicate device open

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - da47343
- Allow xenstore watch

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 3a9a25f
- Working block script

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 8fb76c6
- Do not rely on autoclear

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - e9c921e
- Actually open files to be written for writing :)

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 581fbc2
- more logs

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b67f578
- more logs

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 01ca72f
- test

* Sat Mar 11 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 55b1ea3
- C block script implementation

* Fri Mar 10 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 78a0180
- Link testsuite to ICU

* Fri Mar 10 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 4e5ad00
- fix signs

* Fri Mar 10 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b6e9fe7
- Use uint8_t* with U8_APPEND macros

* Fri Mar 10 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b7de85e
- Generate allowlist at compile-time

* Fri Mar 10 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - f7e4524
- Add some tests

* Fri Mar 10 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - f015a8e
- Fix CentOS 8 build

* Fri Mar 10 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b7b4461
- Create libqubes-pure: a library of Qubes-specific code that does no I/O

